Introduction
The IBM Cloud® Direct Link API is a RESTful API that allows you to manage your Direct Link resources.
compile 'com.ibm.cloud:direct-link:X.X.X'
The code examples on this tab use the client library that is provided for Go.
Installation
go get -u github.com/IBM/networking-go-sdk
go get -u github.com/IBM/go-sdk-core
The code examples on this tab use the client library that is provided for Java.
Maven
<dependency>
<groupId>com.ibm.cloud</groupId>
<artifactId>direct-link</artifactId>
<version>X.X.X</version>
</dependency>
The code examples on this tab use the client library that is provided for Node.js.
Installation
npm install ibm-networking-services
The code examples on this tab use the client library that is provided for Python.
Installation
pip install --upgrade "ibm-cloud-networking-services>=X.X.X"
Authentication
The IBM Cloud Direct Link API uses Identity and Access Management (IAM) to authenticate requests. Pass a bearer token in an Authorization header.
You can retrieve an access token by first creating an API key, and then exchanging your API key for an IBM Cloud IAM token. For more information, see Retrieving an access token programmatically.
The SDK provides initialization methods for each form of authentication.
- Use the API key to have the SDK manage the lifecycle of the access token. The SDK requests an access token, ensures that the access token is valid, and refreshes it if necessary.
- Use the access token to manage the lifecycle yourself. You must periodically refresh the token.
For more information, see Authentication with the SDK.
IAM authentication. Replace {apikey} and {url} with your service credentials.
curl -u "apikey:{apikey}" -X {request_method} "{url}/{method}"
SDK managing the IAM token. Replace {apikey}, {version}, and {url}.
IamAuthenticator authenticator = new IamAuthenticator("{apikey}");
DirectLink directLink = new DirectLink("{version}", "{serviceName}",authenticator);
// Use only when need to change the endpoint.
// Default endpoint is directlink.cloud.ibm.com
directLink.setServiceUrl("{url}")
SDK managing the IAM token. Replace {apikey}, {version}, and {url}.
const DirectLinkV1 = require('ibm-networking-services/direct-link');
const { IamAuthenticator } = require('ibm-cloud-sdk-core');
const directLinkV1 = new DirectLinkV1({
authenticator: new IamAuthenticator({
apikey: '{apikey}',
}),
version: '{version}',
// Default is directlink.cloud.ibm.com
serviceUrl: '{url}',
});
SDK managing the IAM token. Replace {apikey} , {version}, and {url}.
from ibm_cloud_networking_services import DirectLinkV1
from ibm_cloud_sdk_core.authenticators import IAMAuthenticator
authenticator = IAMAuthenticator('{apikey}')
direct_link = DirectLinkV1(
version='{version}',
authenticator=authenticator
)
# Use only when need to change the endpoint.
# Default endpoint is directlink.cloud.ibm.com
direct_link.set_service_url('{url}')
SDK managing the IAM token. Replace {apikey}, {version}, and {url}.
import (
"github.com/IBM/go-sdk-core/core"
"github.com/IBM/networking-go-sdk/directlinkv1"
)
func main() {
authenticator := &core.IamAuthenticator{
ApiKey: "{apikey}",
URL: "{serviceURL}"
}
version := "{version}"
options := &directlinkv1.DirectLinkV1Options{
Version: &version,
Authenticator: authenticator,
// Default is directlink.cloud.ibm.com
URL: "{serviceURL}",
}
directLink, directLinkErr := directlinkv1.NewDirectLinkV1UsingExternalConfig(options)
if directLinkErr != nil {
panic(directLinkErr)
}
}
Auditing
You can monitor API activity within your account by using the IBM Cloud Direct Link service. Whenever an API method is called, an event is generated that you can then track and audit from within Activity Tracker. The specific event type is listed for each individual method.
For more information about how to track IBM Cloud Direct Link activity, see Auditing events for IBM Cloud Direct Link.
Authorization
Access management to Direct Link resources is done through Identity and Access Management (IAM). For more information, see Using IAM permissions with Direct Link.
Error handling
The Direct Link API uses standard HTTP response codes to indicate whether a method completed successfully. A 2xx response indicates success. A 4xx type response indicates a failure, and a 5xx type response indicates an internal system error.
| HTTP Error Code | Description | Recovery |
|---|---|---|
200 |
Success | The request was successful. |
400 |
Bad Request | The input parameters in the request body are either incomplete, in the wrong format, or resources are in an incorrect state. See the specific error message for more details. |
401 |
Unauthorized | You are not authorized to make this request. Log in to IBM Cloud and try again. If this error persists, contact the account owner to check your permissions. |
403 |
Forbidden | The supplied authentication is not authorized to access the requested action. |
404 |
Not Found | The requested resource might not exist, or the supplied authentication is not authorized to access it. See the specific error message for resource details, verify that the specified resource exists, or contact the account owner to check your permissions to view it. |
500 |
Internal Server Error | IBM Cloud API is currently unavailable. Your request might not be processed. Wait a few minutes and try again. If the problem persists, contact IBM Support. |
ErrorResponse
| Name | Description |
|---|---|
| code{: .parameter-name .required} string |
An identifier of the problem. Possible values: [ invalid_field,invalid_header,invalid_method,missing_field,server_error] |
| message{: .parameter-name .required} string |
An explanation of the problem with possible solutions. |
| more_info{: .parameter-name} string |
A URL for more information about the solution. |
| target{: .parameter-name} object |
Details about the property (type and name) that is the focus of the problem. |
The Java SDK generates an exception for any unsuccessful method invocation. All methods that accept an argument can also throw an IllegalArgumentException.
| Exception | Description |
|---|---|
| IllegalArgumentException | An invalid argument was passed to the method. |
When the Java SDK receives an error response from the Direct Link service, it generates an exception from the com.ibm.cloud.sdk.core.service.exception package. All service exceptions contain the following fields.
| Field | Description |
|---|---|
| statusCode | The HTTP response code that is returned. |
| message | A message that describes the error. |
When the Node SDK receives an error response from the Direct Link service, it creates an Error object with information that describes the error that occurred. This error object is passed as the first parameter to the callback function for the method. The contents of the error object are as shown in the following table.
Error
| Field | Description |
|---|---|
| code | The HTTP response code that is returned. |
| message | A message that describes the error. |
The Python SDK generates an exception for any unsuccessful method invocation. When the Python SDK receives an error response from the Direct Link service, it generates an ApiException with the following fields.
| Field | Description |
|---|---|
| code | The HTTP response code that is returned. |
| message | A message that describes the error. |
| info | A dictionary of additional information about the error. |
The Go SDK generates an error for any unsuccessful service instantiation and method invocation. You can check for the error immediately. The contents of the error object are as shown in the following table.
Error
| Field | Description |
|---|---|
| code | The HTTP response code that is returned. |
| message | A message that describes the error. |
Example error handling
try {
// Invoke a Direct Link method
} catch (BadRequestException e) {
// Handle Bad Request (400) exception
} catch (UnauthorizedException e) {
// Handle Unauthorized (401) exception
} catch (ForbiddenException e) {
// Handle Forbidden (403) exception
} catch (NotFoundException e) {
// Handle Not Found (404) exception
} catch (RequestTooLargeException e) {
// Handle Request Too Large (413) exception
} catch (InternalServerErrorException e) {
// Handle Internal Server Error (500) exception
} catch (ServiceResponseException e) {
// Base class for all exceptions caused by error responses from the service
System.out.println("Service returned status code "
+ e.getStatusCode() + ": " + e.getMessage());
}
Example error handling
directLink.method(params)
.catch(err => {
console.log('error:', err);
});
Example error handling
from ibm_cloud_sdk_core.api_exception import ApiException
try:
# Invoke a Direct Link method
except ApiException as ex:
print "Method failed with status code " + str(ex.code) + ": " + ex.message
Example error handling
import "github.com/IBM/networking-go-sdk/directlinkv1"
// Instantiate a service
directLink, directLinkErr := directlinkv1.NewDirectLinkV1(options)
// Check for errors
if directLinkErr != nil {
panic(directLinkErr)
}
// Call a method
result, response, responseErr := directLink.methodName(&methodOptions)
// Check for errors
if responseErr != nil {
panic(responseErr)
}
Versioning
All API requests require a major version in the path (/v1/) and a date-based version as a query parameter in the format version=YYYY-MM-DD.
For example: GET /v1/gateways?version=2020-06-02
Any date-based version from Direct Link GA, up to the current date, is supported. Start development of new applications with the current date as a fixed value. Do not dynamically use the current date as the version for a production application. Instead, use a fixed date-based version that was tested with your application.
Specify the version to use on API requests with the version parameter when you create the service instance. The service uses the API version for the date you specify, or the most recent version before that date. Don't default to the current date. Instead, specify a date that matches a version that is compatible with your app, and don't change it until your app is ready for a later version.
// Mention the correct date for version param
String version = "2020-07-27";
// Instantiate authenticator as mentioned in Authentication
DirectLink directLink = new DirectLink(version, "{serviceName}", "${authenticator}");
const DirectLinkV1 = require('ibm-networking-services/direct-link');
const directLinkV1 = new DirectLinkV1({
// Instantiate authenticator as mentioned in Authentication
authenticator: '${authenticator}',
version: '2020-07-27', // Mention the correct date for version param
});
from ibm_cloud_networking_services import DirectLinkV1
# Instantiate authenticatior as mentioned in Authentication
direct_link = DirectLinkV1(
version="2020-07-27", # Mention the correct date for version param
authenticator=authenticator
)
import (
"github.com/IBM/networking-go-sdk/directlinkv1"
)
func main() {
// Mention the correct date for version param
version := "2020-07-27"
//Instantiate authenticator as mentioned in Authentication
options := &directlinkv1.DirectLinkV1Options{
Version: version,
Authenticator: authenticator,
}
directLink, directLinkErr := directlinkv1.NewDirectLinkV1UsingExternalConfig(options)
}
API changes
API improvements and fixes are documented in the API change log, along with guidance on code updates that are required to use a new date-based version. By design, new features with backward-incompatible changes apply only to version dates on and after the feature's release. Changes that apply to older versions of the API are designed to maintain compatibility with existing applications and code.
Best practices
To minimize regressions from changes, the following best practices are recommended when you call the API:
- Log any
4xxor5xxHTTP status code along with the includedtraceproperty. - Follow HTTP redirect rules for any
3xxHTTP status code. - Consume only the resources and properties that are needed for your application to function.
- Avoid depending on any behavior that is not explicitly documented.
Methods
List gateways
List all Direct Link gateways in this account. Gateways in other accounts with connections to networks in this account are also returned.
List all Direct Link gateways in this account. Gateways in other accounts with connections to networks in this account are also returned.
List all Direct Link gateways in this account. Gateways in other accounts with connections to networks in this account are also returned.
List all Direct Link gateways in this account. Gateways in other accounts with connections to networks in this account are also returned.
List all Direct Link gateways in this account. Gateways in other accounts with connections to networks in this account are also returned.
GET /gateways
ServiceCall<GatewayCollection> listGateways(ListGatewaysOptions listGatewaysOptions)listGateways(params)
list_gateways(
self,
**kwargs,
) -> DetailedResponse(directLink *DirectLinkV1) ListGateways(listGatewaysOptions *ListGatewaysOptions) (result *GatewayCollection, response *core.DetailedResponse, err error)
(directLink *DirectLinkV1) ListGatewaysWithContext(ctx context.Context, listGatewaysOptions *ListGatewaysOptions) (result *GatewayCollection, response *core.DetailedResponse, err error)
Request
Use the ListGatewaysOptions.Builder to create a ListGatewaysOptions object that contains the parameter values for the listGateways method.
Instantiate the ListGatewaysOptions struct and set the fields to provide parameter values for the ListGateways method.
Query Parameters
Requests the version of the API as a date in the format
YYYY-MM-DD. Any date from 2019-12-13 up to the current date may be provided. Specify the current date to request the latest version.Possible values: length = 10, Value must match regular expression
^[0-9]{4}-[0-9]{2}-[0-9]{2}$
parameters
parameters
WithContext method only
A context.Context instance that you can use to specify a timeout for the operation or to cancel an in-flight request.
curl -X GET https://$DL_ENDPOINT/v1/gateways?version=2019-12-13 -H "authorization: Bearer $IAM_TOKEN"
let res; try { res = await directLinkService.listGateways({}); console.log(JSON.stringify(res.result, null, 2)); } catch (err) { console.warn(err); }
ListGatewaysOptions listGatewaysOptions = new ListGatewaysOptions(); Response<GatewayCollection> response = directLinkService.listGateways(listGatewaysOptions).execute(); GatewayCollection gatewayCollection = response.getResult(); System.out.println(gatewayCollection);
listGatewaysOptions := directLinkService.NewListGatewaysOptions() gatewayCollection, response, err := directLinkService.ListGateways(listGatewaysOptions) if err != nil { panic(err) } b, _ := json.MarshalIndent(gatewayCollection, "", " ") fmt.Println(string(b))
response = direct_link_service.list_gateways() gateway_collection = response.get_result() print(json.dumps(gateway_collection, indent=2))
Response
List of gateways
Collection of Direct Link gateways
- gateways
gateway
- undefined
Customer BGP ASN
Example:
64999The date and time resource was created
The CRN (Cloud Resource Name) of this gateway
Example:
crn:v1:bluemix:public:directlink:dal03:a/4111d05f36894e3cb9b46a43556d9000::dedicated:ef4dcb1a-fee4-41c7-9e11-9cd99e65c1f4Indicates whether this gateway is cross account gateway.
Gateways with global routing (
true) can connect to networks outside their associated region.Example:
trueThe unique identifier of this gateway
Example:
ef4dcb1a-fee4-41c7-9e11-9cd99e65c1f4Gateway location long name
Example:
Dallas 03Gateway location
Example:
dal03Metered billing option. When
truegateway usage is billed per gigabyte. Whenfalsethere is no per gigabyte usage charge, instead a flat rate is charged for the gateway.The unique user-defined name for this gateway.
Possible values: 1 ≤ length ≤ 63, Value must match regular expression
^([a-zA-Z]|[a-zA-Z][-_a-zA-Z0-9]*[a-zA-Z0-9])$Example:
myGatewayGateway operational status. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
See
operational_status_reasons[]for possible remediation of thefailedoperational_status.Possible values: [
awaiting_completion_notice,awaiting_loa,configuring,create_pending,create_rejected,completion_notice_approved,completion_notice_received,completion_notice_rejected,delete_pending,loa_accepted,loa_created,loa_rejected,provisioned,failed]Context for certain values of
operational_status.Possible values: 0 ≤ number of items ≤ 10
Gateway speed in megabits per second
Example:
1000Offering type. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
connect,dedicated]Example:
dedicatedarray of AS Prepend information.
Possible values: 0 ≤ number of items ≤ 50
(DEPRECATED) BGP base CIDR is deprecated and no longer recognized by the Direct Link APIs.
See bgp_cer_cidr and bgp_ibm_cidr fields instead for IP related information.
Deprecated field bgp_base_cidr will be removed from the API specification after 15-MAR-2021.
BGP customer edge router CIDR
Example:
10.254.30.78/30IBM BGP ASN
Example:
13884BGP IBM CIDR
Example:
10.254.30.77/30Gateway BGP status. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
active,connect,established,idle]Example:
activeDate and time bgp status was updated
Example:
2020-08-20T06:58:41.909781ZCarrier name. Only set for type=dedicated gateways.
Possible values: 1 ≤ length ≤ 128
Example:
myCarrierNameChanges pending approval for provider managed Direct Link Connect gateways.
Reason for completion notice rejection. Only included on type=dedicated gateways with a rejected completion notice.
Example:
The completion notice file was blankType of services this Gateway is attached to. Mode transit means this Gateway will be attached to Transit Gateway Service and direct means this Gateway will be attached to vpc or classic connection. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
direct,transit]Example:
transitCross connect router. Only included on type=dedicated gateways.
Example:
xcr01.dal03Customer name. Only set for type=dedicated gateways.
Possible values: 1 ≤ length ≤ 128
Example:
newCustomerNameGateway link status. Only included on type=dedicated gateways. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
down,up]Example:
upDate and time link status was updated
Example:
2020-08-20T06:58:41.909781ZGateway patch panel complete notification from implementation team
Example:
patch panel configuration detailsIndicates whether gateway changes must be made via a provider portal.
VLAN configured for this gateway. If there is no vlan configured for the gateway, the vlan will be absent. This property will also be absent if this gateway's
crnis in another account.Example:
10
List of gateways.
Collection of Direct Link gateways.
- gateways
gateway.
- GatewayCollectionGatewaysItem
array of AS Prepend information.
Possible values: 0 ≤ number of items ≤ 50
- asPrepends
The date and time resource was created.
The unique identifier for this AS Prepend.
Possible values: Value must match regular expression
/^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$/Examples:ef4dcb1a-fee4-41c7-9e11-9cd99e65c1f4Number of times the ASN to appended to the AS Path.
Possible values: 3 ≤ value ≤ 10
Examples:4Route type this AS Prepend applies to.
Possible values: [
import,export]Examples:import
Comma separated list of prefixes this AS Prepend applies to. If empty, this applies to all prefixes.
Examples:172.17.0.0/16Array of prefixes this AS Prepend applies to. This parameter is not returned when AS Prepend applies to all prefixes. Note that ordering is not significant and may differ from request order.
Possible values: 1 ≤ number of items ≤ 10, 9 ≤ length ≤ 18, Value must match regular expression
/^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\/(3[0-2]|[1-2][0-9]|[0-9]))$/The date and time resource was last updated.
A reference to a Key Protect Standard Key.
- authenticationKey
The CRN of the referenced key.
Possible values: 9 ≤ length ≤ 512, Value must match regular expression
/^crn:v[0-9](:([A-Za-z0-9-._~!$&'()*+,;=@\/]|%[0-9A-Z]{2})*){2}:kms(:([A-Za-z0-9-._~!$&'()*+,;=@\/]|%[0-9A-Z]{2})*){5}$/Examples:crn:v1:bluemix:public:kms:us-south:a/4111d05f36894e3cb9b46a43556d9000:abc111b8-37aa-4034-9def-f2607c87aaaa:key:bbb222bc-430a-4de9-9aad-84e5bb022222
BFD configuration information.
- bfdConfig
Gateway BFD status. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
init,up,down]Examples:up
Date and time bfd status was updated.
Examples:2020-08-20T06:58:41.909ZMinimum interval in milliseconds at which the local routing device transmits hello packets and then expects to receive a reply from a neighbor with which it has established a BFD session.
Possible values: 300 ≤ value ≤ 255000
Examples:2000The number of hello packets not received by a neighbor that causes the originating interface to be declared down.
Possible values: 1 ≤ value ≤ 255
Examples:10
Customer BGP ASN.
Examples:64999(DEPRECATED) BGP base CIDR is deprecated and no longer recognized by the Direct Link APIs.
See bgp_cer_cidr and bgp_ibm_cidr fields instead for IP related information.
Deprecated field bgp_base_cidr will be removed from the API specification after 15-MAR-2021.
BGP customer edge router CIDR.
Examples:10.254.30.78/30IBM BGP ASN.
Examples:13884BGP IBM CIDR.
Examples:10.254.30.77/30Gateway BGP status. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
active,connect,established,idle]Examples:active
Date and time bgp status was updated.
Examples:2020-08-20T06:58:41.909ZCarrier name. Only set for type=dedicated gateways.
Possible values: 1 ≤ length ≤ 128
Examples:myCarrierName
gateway create.
- changeRequest
type of gateway change request.
Possible values: [
create_gateway]
Reason for completion notice rejection. Only included on type=dedicated gateways with a rejected completion notice.
Examples:The completion notice file was blank
Type of services this Gateway is attached to. Mode transit means this Gateway will be attached to Transit Gateway Service and direct means this Gateway will be attached to vpc or classic connection. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
direct,transit]Examples:transit
The date and time resource was created.
The CRN (Cloud Resource Name) of this gateway.
Examples:crn:v1:bluemix:public:directlink:dal03:a/4111d05f36894e3cb9b46a43556d9000::dedicated:ef4dcb1a-fee4-41c7-9e11-9cd99e65c1f4Indicates whether this gateway is cross account gateway.
Examples:falseCross connect router. Only included on type=dedicated gateways.
Examples:xcr01.dal03
Customer name. Only set for type=dedicated gateways.
Possible values: 1 ≤ length ≤ 128
Examples:newCustomerName
The default directional route filter action that applies to routes that do not match any directional route filters.
Possible values: [
permit,deny]Examples:permit
The default directional route filter action that applies to routes that do not match any directional route filters.
Possible values: [
permit,deny]Examples:permit
Gateways with global routing (
true) can connect to networks outside their associated region.Examples:trueThe unique identifier of this gateway.
Examples:ef4dcb1a-fee4-41c7-9e11-9cd99e65c1f4Gateway link status. Only included on type=dedicated gateways. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
down,up]Examples:up
Date and time link status was updated.
Examples:2020-08-20T06:58:41.909ZGateway location long name.
Examples:Dallas 03Gateway location.
Examples:dal03
MACsec configuration information of a Direct Link gateway.
- macsec
Indicates if the MACsec feature is currently active (true) or inactive (false) for a gateway.
Examples:trueDetermines how packets without MACsec headers are handled.
must_secure- Packets without MACsec headers are dropped. This policy should be used to prefer security over network availability.should_secure- Packets without MACsec headers are allowed. This policy should be used to prefer network availability over security.Possible values: [
must_secure,should_secure]Examples:must_secure
Current status of MACsec on this direct link.
Status
offlineis returned when MACsec is inactive and during direct link creation.Status
deletingis returned when MACsec during removal of MACsec from the direct link and during direct link deletion.See
status_reasons[]for possible remediation of thefailedstatus.Possible values: [
init,pending,offline,secured,failed,deleting]Examples:secured
Context for certain values of
status.Possible values: 0 ≤ number of items ≤ 10
- statusReasons
A reason code for the status:
macsec_cak_failed: At least one of the connectivity association keys (CAKs) associated with the MACsec configuration was unable to be configured on the direct link gateway. Refer to thestatusof the CAKs associated with the MACsec configuration to find the the source of this reason.
Possible values: [
macsec_cak_failed]Examples:macsec_cak_failed
An explanation of the status reason.
Possible values: 0 ≤ length ≤ 250
Examples:The `authentication_key` failed configuration.
Link to documentation about this status reason.
Possible values: 10 ≤ length ≤ 8000, Value must match regular expression
/^http(s)?:\/\/([^\/?#]*)([^?#]*)(\\?([^#]*))?(#(.*))?$/Examples:https://cloud.ibm.com/docs/dl/TODO_ADD_DOCS_LINK
Indicates the direct link's MACsec capability. It must match one of the MACsec related
capabilitiesof thecross_connect_router.Only included on type=dedicated direct links.
- non_macsec: The direct link does not support MACsec.
- macsec: The direct link supports MACsec. The MACsec feature must be enabled.
- macsec_optional: The direct link supports MACsec. The MACsec feature is not required and can be enabled after direct link creation.
Possible values: [
non_macsec,macsec,macsec_optional]Metered billing option. When
truegateway usage is billed per gigabyte. Whenfalsethere is no per gigabyte usage charge, instead a flat rate is charged for the gateway.Examples:falseThe unique user-defined name for this gateway.
Possible values: 1 ≤ length ≤ 63, Value must match regular expression
/^([a-zA-Z]|[a-zA-Z][-_a-zA-Z0-9]*[a-zA-Z0-9])$/Examples:myGateway
Gateway operational status. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
See
operational_status_reasons[]for possible remediation of thefailedoperational_status.Possible values: [
awaiting_completion_notice,awaiting_loa,configuring,create_pending,create_rejected,completion_notice_approved,completion_notice_received,completion_notice_rejected,delete_pending,loa_accepted,loa_created,loa_rejected,provisioned,failed]Context for certain values of
operational_status.Possible values: 0 ≤ number of items ≤ 10
- operationalStatusReasons
A reason code for the status:
authentication_key_failed:authentication_keywas unable to be configured on the direct link gateway. To recover, first resolve any issues with your key, then patch the gateway with the same or new key.
Possible values: [
authentication_key_failed]Examples:authentication_key_failed
An explanation of the status reason.
Possible values: 0 ≤ length ≤ 250
Examples:The `authentication_key` failed configuration.
Link to documentation about this status reason.
Possible values: 10 ≤ length ≤ 8000, Value must match regular expression
/^http(s)?:\/\/([^\/?#]*)([^?#]*)(\\?([^#]*))?(#(.*))?$/Examples:https://cloud.ibm.com/docs/dl/TODO_ADD_DOCS_LINK
Gateway patch panel complete notification from implementation team.
Examples:patch panel configuration details
Port information for type=connect gateways.
- port
Port Identifier.
Examples:54321b1a-fee4-41c7-9e11-9cd99e000aaa
Indicates whether gateway changes must be made via a provider portal.
Examples:falseResource group reference.
- resourceGroup
Resource group identifier.
Examples:56969d6043e9465c883cb9f7363e78e8
Gateway speed in megabits per second.
Examples:1000Offering type. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
connect,dedicated]Examples:dedicated
VLAN configured for this gateway. If there is no vlan configured for the gateway, the vlan will be absent. This property will also be absent if this gateway's
crnis in another account.Examples:10
List of gateways.
Collection of Direct Link gateways.
- gateways
gateway.
- GatewayCollectionGatewaysItem
array of AS Prepend information.
Possible values: 0 ≤ number of items ≤ 50
- as_prepends
The date and time resource was created.
The unique identifier for this AS Prepend.
Possible values: Value must match regular expression
/^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$/Examples:ef4dcb1a-fee4-41c7-9e11-9cd99e65c1f4Number of times the ASN to appended to the AS Path.
Possible values: 3 ≤ value ≤ 10
Examples:4Route type this AS Prepend applies to.
Possible values: [
import,export]Examples:import
Comma separated list of prefixes this AS Prepend applies to. If empty, this applies to all prefixes.
Examples:172.17.0.0/16Array of prefixes this AS Prepend applies to. This parameter is not returned when AS Prepend applies to all prefixes. Note that ordering is not significant and may differ from request order.
Possible values: 1 ≤ number of items ≤ 10, 9 ≤ length ≤ 18, Value must match regular expression
/^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\/(3[0-2]|[1-2][0-9]|[0-9]))$/The date and time resource was last updated.
A reference to a Key Protect Standard Key.
- authentication_key
The CRN of the referenced key.
Possible values: 9 ≤ length ≤ 512, Value must match regular expression
/^crn:v[0-9](:([A-Za-z0-9-._~!$&'()*+,;=@\/]|%[0-9A-Z]{2})*){2}:kms(:([A-Za-z0-9-._~!$&'()*+,;=@\/]|%[0-9A-Z]{2})*){5}$/Examples:crn:v1:bluemix:public:kms:us-south:a/4111d05f36894e3cb9b46a43556d9000:abc111b8-37aa-4034-9def-f2607c87aaaa:key:bbb222bc-430a-4de9-9aad-84e5bb022222
BFD configuration information.
- bfd_config
Gateway BFD status. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
init,up,down]Examples:up
Date and time bfd status was updated.
Examples:2020-08-20T06:58:41.909ZMinimum interval in milliseconds at which the local routing device transmits hello packets and then expects to receive a reply from a neighbor with which it has established a BFD session.
Possible values: 300 ≤ value ≤ 255000
Examples:2000The number of hello packets not received by a neighbor that causes the originating interface to be declared down.
Possible values: 1 ≤ value ≤ 255
Examples:10
Customer BGP ASN.
Examples:64999(DEPRECATED) BGP base CIDR is deprecated and no longer recognized by the Direct Link APIs.
See bgp_cer_cidr and bgp_ibm_cidr fields instead for IP related information.
Deprecated field bgp_base_cidr will be removed from the API specification after 15-MAR-2021.
BGP customer edge router CIDR.
Examples:10.254.30.78/30IBM BGP ASN.
Examples:13884BGP IBM CIDR.
Examples:10.254.30.77/30Gateway BGP status. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
active,connect,established,idle]Examples:active
Date and time bgp status was updated.
Examples:2020-08-20T06:58:41.909ZCarrier name. Only set for type=dedicated gateways.
Possible values: 1 ≤ length ≤ 128
Examples:myCarrierName
gateway create.
- change_request
type of gateway change request.
Possible values: [
create_gateway]
Reason for completion notice rejection. Only included on type=dedicated gateways with a rejected completion notice.
Examples:The completion notice file was blank
Type of services this Gateway is attached to. Mode transit means this Gateway will be attached to Transit Gateway Service and direct means this Gateway will be attached to vpc or classic connection. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
direct,transit]Examples:transit
The date and time resource was created.
The CRN (Cloud Resource Name) of this gateway.
Examples:crn:v1:bluemix:public:directlink:dal03:a/4111d05f36894e3cb9b46a43556d9000::dedicated:ef4dcb1a-fee4-41c7-9e11-9cd99e65c1f4Indicates whether this gateway is cross account gateway.
Examples:falseCross connect router. Only included on type=dedicated gateways.
Examples:xcr01.dal03
Customer name. Only set for type=dedicated gateways.
Possible values: 1 ≤ length ≤ 128
Examples:newCustomerName
The default directional route filter action that applies to routes that do not match any directional route filters.
Possible values: [
permit,deny]Examples:permit
The default directional route filter action that applies to routes that do not match any directional route filters.
Possible values: [
permit,deny]Examples:permit
Gateways with global routing (
true) can connect to networks outside their associated region.Examples:trueThe unique identifier of this gateway.
Examples:ef4dcb1a-fee4-41c7-9e11-9cd99e65c1f4Gateway link status. Only included on type=dedicated gateways. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
down,up]Examples:up
Date and time link status was updated.
Examples:2020-08-20T06:58:41.909ZGateway location long name.
Examples:Dallas 03Gateway location.
Examples:dal03
MACsec configuration information of a Direct Link gateway.
- macsec
Indicates if the MACsec feature is currently active (true) or inactive (false) for a gateway.
Examples:trueDetermines how packets without MACsec headers are handled.
must_secure- Packets without MACsec headers are dropped. This policy should be used to prefer security over network availability.should_secure- Packets without MACsec headers are allowed. This policy should be used to prefer network availability over security.Possible values: [
must_secure,should_secure]Examples:must_secure
Current status of MACsec on this direct link.
Status
offlineis returned when MACsec is inactive and during direct link creation.Status
deletingis returned when MACsec during removal of MACsec from the direct link and during direct link deletion.See
status_reasons[]for possible remediation of thefailedstatus.Possible values: [
init,pending,offline,secured,failed,deleting]Examples:secured
Context for certain values of
status.Possible values: 0 ≤ number of items ≤ 10
- status_reasons
A reason code for the status:
macsec_cak_failed: At least one of the connectivity association keys (CAKs) associated with the MACsec configuration was unable to be configured on the direct link gateway. Refer to thestatusof the CAKs associated with the MACsec configuration to find the the source of this reason.
Possible values: [
macsec_cak_failed]Examples:macsec_cak_failed
An explanation of the status reason.
Possible values: 0 ≤ length ≤ 250
Examples:The `authentication_key` failed configuration.
Link to documentation about this status reason.
Possible values: 10 ≤ length ≤ 8000, Value must match regular expression
/^http(s)?:\/\/([^\/?#]*)([^?#]*)(\\?([^#]*))?(#(.*))?$/Examples:https://cloud.ibm.com/docs/dl/TODO_ADD_DOCS_LINK
Indicates the direct link's MACsec capability. It must match one of the MACsec related
capabilitiesof thecross_connect_router.Only included on type=dedicated direct links.
- non_macsec: The direct link does not support MACsec.
- macsec: The direct link supports MACsec. The MACsec feature must be enabled.
- macsec_optional: The direct link supports MACsec. The MACsec feature is not required and can be enabled after direct link creation.
Possible values: [
non_macsec,macsec,macsec_optional]Metered billing option. When
truegateway usage is billed per gigabyte. Whenfalsethere is no per gigabyte usage charge, instead a flat rate is charged for the gateway.Examples:falseThe unique user-defined name for this gateway.
Possible values: 1 ≤ length ≤ 63, Value must match regular expression
/^([a-zA-Z]|[a-zA-Z][-_a-zA-Z0-9]*[a-zA-Z0-9])$/Examples:myGateway
Gateway operational status. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
See
operational_status_reasons[]for possible remediation of thefailedoperational_status.Possible values: [
awaiting_completion_notice,awaiting_loa,configuring,create_pending,create_rejected,completion_notice_approved,completion_notice_received,completion_notice_rejected,delete_pending,loa_accepted,loa_created,loa_rejected,provisioned,failed]Context for certain values of
operational_status.Possible values: 0 ≤ number of items ≤ 10
- operational_status_reasons
A reason code for the status:
authentication_key_failed:authentication_keywas unable to be configured on the direct link gateway. To recover, first resolve any issues with your key, then patch the gateway with the same or new key.
Possible values: [
authentication_key_failed]Examples:authentication_key_failed
An explanation of the status reason.
Possible values: 0 ≤ length ≤ 250
Examples:The `authentication_key` failed configuration.
Link to documentation about this status reason.
Possible values: 10 ≤ length ≤ 8000, Value must match regular expression
/^http(s)?:\/\/([^\/?#]*)([^?#]*)(\\?([^#]*))?(#(.*))?$/Examples:https://cloud.ibm.com/docs/dl/TODO_ADD_DOCS_LINK
Gateway patch panel complete notification from implementation team.
Examples:patch panel configuration details
Port information for type=connect gateways.
- port
Port Identifier.
Examples:54321b1a-fee4-41c7-9e11-9cd99e000aaa
Indicates whether gateway changes must be made via a provider portal.
Examples:falseResource group reference.
- resource_group
Resource group identifier.
Examples:56969d6043e9465c883cb9f7363e78e8
Gateway speed in megabits per second.
Examples:1000Offering type. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
connect,dedicated]Examples:dedicated
VLAN configured for this gateway. If there is no vlan configured for the gateway, the vlan will be absent. This property will also be absent if this gateway's
crnis in another account.Examples:10
List of gateways.
Collection of Direct Link gateways.
- gateways
gateway.
- GatewayCollectionGatewaysItem
array of AS Prepend information.
Possible values: 0 ≤ number of items ≤ 50
- as_prepends
The date and time resource was created.
The unique identifier for this AS Prepend.
Possible values: Value must match regular expression
/^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$/Examples:ef4dcb1a-fee4-41c7-9e11-9cd99e65c1f4Number of times the ASN to appended to the AS Path.
Possible values: 3 ≤ value ≤ 10
Examples:4Route type this AS Prepend applies to.
Possible values: [
import,export]Examples:import
Comma separated list of prefixes this AS Prepend applies to. If empty, this applies to all prefixes.
Examples:172.17.0.0/16Array of prefixes this AS Prepend applies to. This parameter is not returned when AS Prepend applies to all prefixes. Note that ordering is not significant and may differ from request order.
Possible values: 1 ≤ number of items ≤ 10, 9 ≤ length ≤ 18, Value must match regular expression
/^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\/(3[0-2]|[1-2][0-9]|[0-9]))$/The date and time resource was last updated.
A reference to a Key Protect Standard Key.
- authentication_key
The CRN of the referenced key.
Possible values: 9 ≤ length ≤ 512, Value must match regular expression
/^crn:v[0-9](:([A-Za-z0-9-._~!$&'()*+,;=@\/]|%[0-9A-Z]{2})*){2}:kms(:([A-Za-z0-9-._~!$&'()*+,;=@\/]|%[0-9A-Z]{2})*){5}$/Examples:crn:v1:bluemix:public:kms:us-south:a/4111d05f36894e3cb9b46a43556d9000:abc111b8-37aa-4034-9def-f2607c87aaaa:key:bbb222bc-430a-4de9-9aad-84e5bb022222
BFD configuration information.
- bfd_config
Gateway BFD status. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
init,up,down]Examples:up
Date and time bfd status was updated.
Examples:2020-08-20T06:58:41.909ZMinimum interval in milliseconds at which the local routing device transmits hello packets and then expects to receive a reply from a neighbor with which it has established a BFD session.
Possible values: 300 ≤ value ≤ 255000
Examples:2000The number of hello packets not received by a neighbor that causes the originating interface to be declared down.
Possible values: 1 ≤ value ≤ 255
Examples:10
Customer BGP ASN.
Examples:64999(DEPRECATED) BGP base CIDR is deprecated and no longer recognized by the Direct Link APIs.
See bgp_cer_cidr and bgp_ibm_cidr fields instead for IP related information.
Deprecated field bgp_base_cidr will be removed from the API specification after 15-MAR-2021.
BGP customer edge router CIDR.
Examples:10.254.30.78/30IBM BGP ASN.
Examples:13884BGP IBM CIDR.
Examples:10.254.30.77/30Gateway BGP status. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
active,connect,established,idle]Examples:active
Date and time bgp status was updated.
Examples:2020-08-20T06:58:41.909ZCarrier name. Only set for type=dedicated gateways.
Possible values: 1 ≤ length ≤ 128
Examples:myCarrierName
gateway create.
- change_request
type of gateway change request.
Possible values: [
create_gateway]
Reason for completion notice rejection. Only included on type=dedicated gateways with a rejected completion notice.
Examples:The completion notice file was blank
Type of services this Gateway is attached to. Mode transit means this Gateway will be attached to Transit Gateway Service and direct means this Gateway will be attached to vpc or classic connection. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
direct,transit]Examples:transit
The date and time resource was created.
The CRN (Cloud Resource Name) of this gateway.
Examples:crn:v1:bluemix:public:directlink:dal03:a/4111d05f36894e3cb9b46a43556d9000::dedicated:ef4dcb1a-fee4-41c7-9e11-9cd99e65c1f4Indicates whether this gateway is cross account gateway.
Examples:falseCross connect router. Only included on type=dedicated gateways.
Examples:xcr01.dal03
Customer name. Only set for type=dedicated gateways.
Possible values: 1 ≤ length ≤ 128
Examples:newCustomerName
The default directional route filter action that applies to routes that do not match any directional route filters.
Possible values: [
permit,deny]Examples:permit
The default directional route filter action that applies to routes that do not match any directional route filters.
Possible values: [
permit,deny]Examples:permit
Gateways with global routing (
true) can connect to networks outside their associated region.Examples:trueThe unique identifier of this gateway.
Examples:ef4dcb1a-fee4-41c7-9e11-9cd99e65c1f4Gateway link status. Only included on type=dedicated gateways. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
down,up]Examples:up
Date and time link status was updated.
Examples:2020-08-20T06:58:41.909ZGateway location long name.
Examples:Dallas 03Gateway location.
Examples:dal03
MACsec configuration information of a Direct Link gateway.
- macsec
Indicates if the MACsec feature is currently active (true) or inactive (false) for a gateway.
Examples:trueDetermines how packets without MACsec headers are handled.
must_secure- Packets without MACsec headers are dropped. This policy should be used to prefer security over network availability.should_secure- Packets without MACsec headers are allowed. This policy should be used to prefer network availability over security.Possible values: [
must_secure,should_secure]Examples:must_secure
Current status of MACsec on this direct link.
Status
offlineis returned when MACsec is inactive and during direct link creation.Status
deletingis returned when MACsec during removal of MACsec from the direct link and during direct link deletion.See
status_reasons[]for possible remediation of thefailedstatus.Possible values: [
init,pending,offline,secured,failed,deleting]Examples:secured
Context for certain values of
status.Possible values: 0 ≤ number of items ≤ 10
- status_reasons
A reason code for the status:
macsec_cak_failed: At least one of the connectivity association keys (CAKs) associated with the MACsec configuration was unable to be configured on the direct link gateway. Refer to thestatusof the CAKs associated with the MACsec configuration to find the the source of this reason.
Possible values: [
macsec_cak_failed]Examples:macsec_cak_failed
An explanation of the status reason.
Possible values: 0 ≤ length ≤ 250
Examples:The `authentication_key` failed configuration.
Link to documentation about this status reason.
Possible values: 10 ≤ length ≤ 8000, Value must match regular expression
/^http(s)?:\/\/([^\/?#]*)([^?#]*)(\\?([^#]*))?(#(.*))?$/Examples:https://cloud.ibm.com/docs/dl/TODO_ADD_DOCS_LINK
Indicates the direct link's MACsec capability. It must match one of the MACsec related
capabilitiesof thecross_connect_router.Only included on type=dedicated direct links.
- non_macsec: The direct link does not support MACsec.
- macsec: The direct link supports MACsec. The MACsec feature must be enabled.
- macsec_optional: The direct link supports MACsec. The MACsec feature is not required and can be enabled after direct link creation.
Possible values: [
non_macsec,macsec,macsec_optional]Metered billing option. When
truegateway usage is billed per gigabyte. Whenfalsethere is no per gigabyte usage charge, instead a flat rate is charged for the gateway.Examples:falseThe unique user-defined name for this gateway.
Possible values: 1 ≤ length ≤ 63, Value must match regular expression
/^([a-zA-Z]|[a-zA-Z][-_a-zA-Z0-9]*[a-zA-Z0-9])$/Examples:myGateway
Gateway operational status. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
See
operational_status_reasons[]for possible remediation of thefailedoperational_status.Possible values: [
awaiting_completion_notice,awaiting_loa,configuring,create_pending,create_rejected,completion_notice_approved,completion_notice_received,completion_notice_rejected,delete_pending,loa_accepted,loa_created,loa_rejected,provisioned,failed]Context for certain values of
operational_status.Possible values: 0 ≤ number of items ≤ 10
- operational_status_reasons
A reason code for the status:
authentication_key_failed:authentication_keywas unable to be configured on the direct link gateway. To recover, first resolve any issues with your key, then patch the gateway with the same or new key.
Possible values: [
authentication_key_failed]Examples:authentication_key_failed
An explanation of the status reason.
Possible values: 0 ≤ length ≤ 250
Examples:The `authentication_key` failed configuration.
Link to documentation about this status reason.
Possible values: 10 ≤ length ≤ 8000, Value must match regular expression
/^http(s)?:\/\/([^\/?#]*)([^?#]*)(\\?([^#]*))?(#(.*))?$/Examples:https://cloud.ibm.com/docs/dl/TODO_ADD_DOCS_LINK
Gateway patch panel complete notification from implementation team.
Examples:patch panel configuration details
Port information for type=connect gateways.
- port
Port Identifier.
Examples:54321b1a-fee4-41c7-9e11-9cd99e000aaa
Indicates whether gateway changes must be made via a provider portal.
Examples:falseResource group reference.
- resource_group
Resource group identifier.
Examples:56969d6043e9465c883cb9f7363e78e8
Gateway speed in megabits per second.
Examples:1000Offering type. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
connect,dedicated]Examples:dedicated
VLAN configured for this gateway. If there is no vlan configured for the gateway, the vlan will be absent. This property will also be absent if this gateway's
crnis in another account.Examples:10
List of gateways.
Collection of Direct Link gateways.
- Gateways
gateway.
- GatewayCollectionGatewaysItem
array of AS Prepend information.
Possible values: 0 ≤ number of items ≤ 50
- AsPrepends
The date and time resource was created.
The unique identifier for this AS Prepend.
Possible values: Value must match regular expression
/^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$/Examples:ef4dcb1a-fee4-41c7-9e11-9cd99e65c1f4Number of times the ASN to appended to the AS Path.
Possible values: 3 ≤ value ≤ 10
Examples:4Route type this AS Prepend applies to.
Possible values: [
import,export]Examples:import
Comma separated list of prefixes this AS Prepend applies to. If empty, this applies to all prefixes.
Examples:172.17.0.0/16Array of prefixes this AS Prepend applies to. This parameter is not returned when AS Prepend applies to all prefixes. Note that ordering is not significant and may differ from request order.
Possible values: 1 ≤ number of items ≤ 10, 9 ≤ length ≤ 18, Value must match regular expression
/^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\/(3[0-2]|[1-2][0-9]|[0-9]))$/The date and time resource was last updated.
A reference to a Key Protect Standard Key.
- AuthenticationKey
The CRN of the referenced key.
Possible values: 9 ≤ length ≤ 512, Value must match regular expression
/^crn:v[0-9](:([A-Za-z0-9-._~!$&'()*+,;=@\/]|%[0-9A-Z]{2})*){2}:kms(:([A-Za-z0-9-._~!$&'()*+,;=@\/]|%[0-9A-Z]{2})*){5}$/Examples:crn:v1:bluemix:public:kms:us-south:a/4111d05f36894e3cb9b46a43556d9000:abc111b8-37aa-4034-9def-f2607c87aaaa:key:bbb222bc-430a-4de9-9aad-84e5bb022222
BFD configuration information.
- BfdConfig
Gateway BFD status. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
init,up,down]Examples:up
Date and time bfd status was updated.
Examples:2020-08-20T06:58:41.909ZMinimum interval in milliseconds at which the local routing device transmits hello packets and then expects to receive a reply from a neighbor with which it has established a BFD session.
Possible values: 300 ≤ value ≤ 255000
Examples:2000The number of hello packets not received by a neighbor that causes the originating interface to be declared down.
Possible values: 1 ≤ value ≤ 255
Examples:10
Customer BGP ASN.
Examples:64999(DEPRECATED) BGP base CIDR is deprecated and no longer recognized by the Direct Link APIs.
See bgp_cer_cidr and bgp_ibm_cidr fields instead for IP related information.
Deprecated field bgp_base_cidr will be removed from the API specification after 15-MAR-2021.
BGP customer edge router CIDR.
Examples:10.254.30.78/30IBM BGP ASN.
Examples:13884BGP IBM CIDR.
Examples:10.254.30.77/30Gateway BGP status. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
active,connect,established,idle]Examples:active
Date and time bgp status was updated.
Examples:2020-08-20T06:58:41.909ZCarrier name. Only set for type=dedicated gateways.
Possible values: 1 ≤ length ≤ 128
Examples:myCarrierName
gateway create.
- ChangeRequest
type of gateway change request.
Possible values: [
create_gateway]
Reason for completion notice rejection. Only included on type=dedicated gateways with a rejected completion notice.
Examples:The completion notice file was blank
Type of services this Gateway is attached to. Mode transit means this Gateway will be attached to Transit Gateway Service and direct means this Gateway will be attached to vpc or classic connection. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
direct,transit]Examples:transit
The date and time resource was created.
The CRN (Cloud Resource Name) of this gateway.
Examples:crn:v1:bluemix:public:directlink:dal03:a/4111d05f36894e3cb9b46a43556d9000::dedicated:ef4dcb1a-fee4-41c7-9e11-9cd99e65c1f4Indicates whether this gateway is cross account gateway.
Examples:falseCross connect router. Only included on type=dedicated gateways.
Examples:xcr01.dal03
Customer name. Only set for type=dedicated gateways.
Possible values: 1 ≤ length ≤ 128
Examples:newCustomerName
The default directional route filter action that applies to routes that do not match any directional route filters.
Possible values: [
permit,deny]Examples:permit
The default directional route filter action that applies to routes that do not match any directional route filters.
Possible values: [
permit,deny]Examples:permit
Gateways with global routing (
true) can connect to networks outside their associated region.Examples:trueThe unique identifier of this gateway.
Examples:ef4dcb1a-fee4-41c7-9e11-9cd99e65c1f4Gateway link status. Only included on type=dedicated gateways. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
down,up]Examples:up
Date and time link status was updated.
Examples:2020-08-20T06:58:41.909ZGateway location long name.
Examples:Dallas 03Gateway location.
Examples:dal03
MACsec configuration information of a Direct Link gateway.
- Macsec
Indicates if the MACsec feature is currently active (true) or inactive (false) for a gateway.
Examples:trueDetermines how packets without MACsec headers are handled.
must_secure- Packets without MACsec headers are dropped. This policy should be used to prefer security over network availability.should_secure- Packets without MACsec headers are allowed. This policy should be used to prefer network availability over security.Possible values: [
must_secure,should_secure]Examples:must_secure
Current status of MACsec on this direct link.
Status
offlineis returned when MACsec is inactive and during direct link creation.Status
deletingis returned when MACsec during removal of MACsec from the direct link and during direct link deletion.See
status_reasons[]for possible remediation of thefailedstatus.Possible values: [
init,pending,offline,secured,failed,deleting]Examples:secured
Context for certain values of
status.Possible values: 0 ≤ number of items ≤ 10
- StatusReasons
A reason code for the status:
macsec_cak_failed: At least one of the connectivity association keys (CAKs) associated with the MACsec configuration was unable to be configured on the direct link gateway. Refer to thestatusof the CAKs associated with the MACsec configuration to find the the source of this reason.
Possible values: [
macsec_cak_failed]Examples:macsec_cak_failed
An explanation of the status reason.
Possible values: 0 ≤ length ≤ 250
Examples:The `authentication_key` failed configuration.
Link to documentation about this status reason.
Possible values: 10 ≤ length ≤ 8000, Value must match regular expression
/^http(s)?:\/\/([^\/?#]*)([^?#]*)(\\?([^#]*))?(#(.*))?$/Examples:https://cloud.ibm.com/docs/dl/TODO_ADD_DOCS_LINK
Indicates the direct link's MACsec capability. It must match one of the MACsec related
capabilitiesof thecross_connect_router.Only included on type=dedicated direct links.
- non_macsec: The direct link does not support MACsec.
- macsec: The direct link supports MACsec. The MACsec feature must be enabled.
- macsec_optional: The direct link supports MACsec. The MACsec feature is not required and can be enabled after direct link creation.
Possible values: [
non_macsec,macsec,macsec_optional]Metered billing option. When
truegateway usage is billed per gigabyte. Whenfalsethere is no per gigabyte usage charge, instead a flat rate is charged for the gateway.Examples:falseThe unique user-defined name for this gateway.
Possible values: 1 ≤ length ≤ 63, Value must match regular expression
/^([a-zA-Z]|[a-zA-Z][-_a-zA-Z0-9]*[a-zA-Z0-9])$/Examples:myGateway
Gateway operational status. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
See
operational_status_reasons[]for possible remediation of thefailedoperational_status.Possible values: [
awaiting_completion_notice,awaiting_loa,configuring,create_pending,create_rejected,completion_notice_approved,completion_notice_received,completion_notice_rejected,delete_pending,loa_accepted,loa_created,loa_rejected,provisioned,failed]Context for certain values of
operational_status.Possible values: 0 ≤ number of items ≤ 10
- OperationalStatusReasons
A reason code for the status:
authentication_key_failed:authentication_keywas unable to be configured on the direct link gateway. To recover, first resolve any issues with your key, then patch the gateway with the same or new key.
Possible values: [
authentication_key_failed]Examples:authentication_key_failed
An explanation of the status reason.
Possible values: 0 ≤ length ≤ 250
Examples:The `authentication_key` failed configuration.
Link to documentation about this status reason.
Possible values: 10 ≤ length ≤ 8000, Value must match regular expression
/^http(s)?:\/\/([^\/?#]*)([^?#]*)(\\?([^#]*))?(#(.*))?$/Examples:https://cloud.ibm.com/docs/dl/TODO_ADD_DOCS_LINK
Gateway patch panel complete notification from implementation team.
Examples:patch panel configuration details
Port information for type=connect gateways.
- Port
Port Identifier.
Examples:54321b1a-fee4-41c7-9e11-9cd99e000aaa
Indicates whether gateway changes must be made via a provider portal.
Examples:falseResource group reference.
- ResourceGroup
Resource group identifier.
Examples:56969d6043e9465c883cb9f7363e78e8
Gateway speed in megabits per second.
Examples:1000Offering type. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Possible values: [
connect,dedicated]Examples:dedicated
VLAN configured for this gateway. If there is no vlan configured for the gateway, the vlan will be absent. This property will also be absent if this gateway's
crnis in another account.Examples:10
Status Code
Successfully retrieved the list of gateways.
{ "gateways": [ { "as_prepends": [ { "created_at": "2020-11-02T20:40:29.622Z", "id": "ef4dcb1a-fee4-41c7-9e11-9cd99e65c999", "length": 4, "policy": "import", "prefix": "172.17.0.0/16", "updated_at": "2020-11-02T20:40:29.622Z" } ], "authentication_key": { "crn": "crn:v1:bluemix:public:kms:us-south:a/766d8d374a484f029d0fca5a40a52a1c:5d343839-07d3-4213-a950-0f71ed45423f:key:7fc1a0ba-4633-48cb-997b-5749787c952c" }, "bgp_asn": 64999, "bgp_cer_cidr": "10.254.30.78/30", "bgp_ibm_asn": 13884, "bgp_ibm_cidr": "10.254.30.77/30", "bgp_status": "active", "connection_mode": "transit", "created_at": "2020-11-02T20:40:29.622Z", "crn": "crn:v1:bluemix:public:directlink:dal00:a/aaaaaaaa4a484f029d0fca5a11111111::connect:bbbbbbbb-f326-428f-a345-222222222222", "cross_account": false, "cross_connect_router": "xcr01.dal03", "default_export_route_filter": "permit", "default_import_route_filter": "deny", "global": true, "id": "ef4dcb1a-fee4-41c7-9e11-9cd99e65c1f4", "link_status": "up", "location_display_name": "Dallas 03", "location_name": "dal03", "metered": false, "name": "example-gateway", "operational_status": "provisioned", "operational_status_reasons": [], "resource_group": { "id": "54321b1a-fee4-41c7-9e11-9cd99e000aaa" }, "speed_mbps": 1000, "type": "dedicated" } ] }{ "gateways": [ { "as_prepends": [ { "created_at": "2020-11-02T20:40:29.622Z", "id": "ef4dcb1a-fee4-41c7-9e11-9cd99e65c999", "length": 4, "policy": "import", "prefix": "172.17.0.0/16", "updated_at": "2020-11-02T20:40:29.622Z" } ], "authentication_key": { "crn": "crn:v1:bluemix:public:kms:us-south:a/766d8d374a484f029d0fca5a40a52a1c:5d343839-07d3-4213-a950-0f71ed45423f:key:7fc1a0ba-4633-48cb-997b-5749787c952c" }, "bgp_asn": 64999, "bgp_cer_cidr": "10.254.30.78/30", "bgp_ibm_asn": 13884, "bgp_ibm_cidr": "10.254.30.77/30", "bgp_status": "active", "connection_mode": "transit", "created_at": "2020-11-02T20:40:29.622Z", "crn": "crn:v1:bluemix:public:directlink:dal00:a/aaaaaaaa4a484f029d0fca5a11111111::connect:bbbbbbbb-f326-428f-a345-222222222222", "cross_account": false, "cross_connect_router": "xcr01.dal03", "default_export_route_filter": "permit", "default_import_route_filter": "deny", "global": true, "id": "ef4dcb1a-fee4-41c7-9e11-9cd99e65c1f4", "link_status": "up", "location_display_name": "Dallas 03", "location_name": "dal03", "metered": false, "name": "example-gateway", "operational_status": "provisioned", "operational_status_reasons": [], "resource_group": { "id": "54321b1a-fee4-41c7-9e11-9cd99e000aaa" }, "speed_mbps": 1000, "type": "dedicated" } ] }
Create gateway
Creates a Direct Link gateway based on the supplied template.
Creates a Direct Link gateway based on the supplied template.
Creates a Direct Link gateway based on the supplied template.
Creates a Direct Link gateway based on the supplied template.
Creates a Direct Link gateway based on the supplied template.
POST /gateways
ServiceCall<Gateway> createGateway(CreateGatewayOptions createGatewayOptions)createGateway(params)
create_gateway(
self,
gateway_template: 'GatewayTemplate',
**kwargs,
) -> DetailedResponse(directLink *DirectLinkV1) CreateGateway(createGatewayOptions *CreateGatewayOptions) (result *Gateway, response *core.DetailedResponse, err error)
(directLink *DirectLinkV1) CreateGatewayWithContext(ctx context.Context, createGatewayOptions *CreateGatewayOptions) (result *Gateway, response *core.DetailedResponse, err error)
Request
Use the CreateGatewayOptions.Builder to create a CreateGatewayOptions object that contains the parameter values for the createGateway method.
Instantiate the CreateGatewayOptions struct and set the fields to provide parameter values for the CreateGateway method.
Query Parameters
Requests the version of the API as a date in the format
YYYY-MM-DD. Any date from 2019-12-13 up to the current date may be provided. Specify the current date to request the latest version.Possible values: length = 10, Value must match regular expression
^[0-9]{4}-[0-9]{2}-[0-9]{2}$
The Direct Link Gateway template
BGP ASN
Example:
64999Gateways with global routing (
true) can connect to networks outside their associated region.Example:
trueMetered billing option. When
truegateway usage is billed per gigabyte. Whenfalsethere is no per gigabyte usage charge, instead a flat rate is charged for the gateway.The unique user-defined name for this gateway.
Example:
myGatewayGateway speed in megabits per second
Example:
1000Offering type
Allowable values: [
connect,dedicated]Example:
dedicatedarray of AS Prepend configuration information.
Possible values: 0 ≤ number of items ≤ 50
BFD configuration information.
(DEPRECATED) BGP base CIDR.
Field is deprecated. See bgp_ibm_cidr and bgp_cer_cidr for details on how to create a gateway using either automatic or explicit IP assignment. Any bgp_base_cidr value set will be ignored.
Deprecated field bgp_base_cidr will be removed from the API specification after 15-MAR-2021.
BGP customer edge router CIDR.
For auto IP assignment, omit bgp_cer_cidr and bgp_ibm_cidr. IBM will automatically select values for bgp_cer_cidr and bgp_ibm_cidr.
For explicit IP assignment set a valid bgp_cer_cidr and bgp_ibm_cidr CIDR, the value must reside in one of "10.254.0.0/16", "172.16.0.0/12", "192.168.0.0/16", "169.254.0.0/16" or an owned public CIDR. bgp_cer_cidr and bgp_ibm_cidr must have matching network and subnet mask values.
Example:
169.254.0.10/30BGP IBM CIDR.
For auto IP assignment, omit bgp_cer_cidr and bgp_ibm_cidr. IBM will automatically select values for bgp_cer_cidr and bgp_ibm_cidr.
For explicit IP assignment set a valid bgp_cer_cidr and bgp_ibm_cidr CIDR, the value must reside in one of "10.254.0.0/16", "172.16.0.0/12", "192.168.0.0/16", "169.254.0.0/16" or an owned public CIDR. bgp_cer_cidr and bgp_ibm_cidr must have matching network and subnet mask values.
Example:
169.254.0.9/30Type of services this Gateway is attached to. Mode transit means this Gateway will be attached to Transit Gateway Service and direct means this Gateway will be attached to vpc or classic connection. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Allowable values: [
direct,transit]Default:
directExample:
transitThe default directional route filter action that applies to routes that do not match any directional route filters.
Allowable values: [
permit,deny]Default:
permitExample:
permitThe default directional route filter action that applies to routes that do not match any directional route filters.
Allowable values: [
permit,deny]Default:
permitExample:
permitArray of directional route filters for a Direct Link gateway. When creating a gateway or replacing existing route filters, the order of the items in the array will set the ordering of the list of route filters.
Possible values: 0 ≤ number of items ≤ 100
Array of directional route filters for a Direct Link gateway. When creating a gateway or replacing existing route filters, the order of the items in the array will set the ordering of the list of route filters.
Possible values: 0 ≤ number of items ≤ 100
Gateway patch panel complete notification from implementation team
Example:
patch panel configuration detailsResource group for this resource. If unspecified, the account's default resource group is used.
Gateway fields specific to type=dedicated gateway create
- One of
Carrier name
Possible values: 1 ≤ length ≤ 128, Value must match regular expression
^[a-zA-Z0-9 _-]+$Example:
myCarrierNameCross connect router
Example:
xcr01.dal03Customer name
Possible values: 1 ≤ length ≤ 128, Value must match regular expression
^[a-zA-Z0-9 _-]+$Example:
newCustomerNameGateway location
Example:
dal03The VLAN to configure for this gateway.
Possible values: 2 ≤ value ≤ 3967
Example:
10
The createGateway options.
Gateway fields specific to type=dedicated gateway create.
- gatewayTemplate
array of AS Prepend configuration information.
Possible values: 0 ≤ number of items ≤ 50
- asPrepends
Number of times the ASN to be prepended to the AS Path.
Possible values: 3 ≤ value ≤ 10
Examples:4Route type this AS Prepend applies to.
Allowable values: [
import,export]Examples:import
Comma separated list of prefixes this AS Prepend applies to. Maximum of 10 prefixes. If not specified, this AS Prepend applies to all prefixes.
Examples:172.17.0.0/16Array of prefixes this AS Prepend applies to. If this property is absent, the AS Prepend applies to all prefixes.
Possible values: 1 ≤ number of items ≤ 10, 9 ≤ length ≤ 18, Value must match regular expression
/^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\/(3[0-2]|[1-2][0-9]|[0-9]))$/
- authenticationKey
The CRN of the key.
Possible values: 9 ≤ length ≤ 512, Value must match regular expression
/^crn:v[0-9](:([A-Za-z0-9-._~!$&'()*+,;=@\/]|%[0-9A-Z]{2})*){2}:kms(:([A-Za-z0-9-._~!$&'()*+,;=@\/]|%[0-9A-Z]{2})*){5}$/Examples:crn:v1:bluemix:public:kms:us-south:a/4111d05f36894e3cb9b46a43556d9000:abc111b8-37aa-4034-9def-f2607c87aaaa:key:bbb222bc-430a-4de9-9aad-84e5bb022222
BFD configuration information.
- bfdConfig
Minimum interval in milliseconds at which the local routing device transmits hello packets and then expects to receive a reply from a neighbor with which it has established a BFD session.
Possible values: 300 ≤ value ≤ 255000
Examples:2000The number of hello packets not received by a neighbor that causes the originating interface to be declared down.
Possible values: 1 ≤ value ≤ 255
Default:
3Examples:10
BGP ASN.
Examples:64999(DEPRECATED) BGP base CIDR.
Field is deprecated. See bgp_ibm_cidr and bgp_cer_cidr for details on how to create a gateway using either automatic or explicit IP assignment. Any bgp_base_cidr value set will be ignored.
Deprecated field bgp_base_cidr will be removed from the API specification after 15-MAR-2021.
BGP customer edge router CIDR.
For auto IP assignment, omit bgp_cer_cidr and bgp_ibm_cidr. IBM will automatically select values for bgp_cer_cidr and bgp_ibm_cidr.
For explicit IP assignment set a valid bgp_cer_cidr and bgp_ibm_cidr CIDR, the value must reside in one of "10.254.0.0/16", "172.16.0.0/12", "192.168.0.0/16", "169.254.0.0/16" or an owned public CIDR. bgp_cer_cidr and bgp_ibm_cidr must have matching network and subnet mask values.
Examples:169.254.0.10/30BGP IBM CIDR.
For auto IP assignment, omit bgp_cer_cidr and bgp_ibm_cidr. IBM will automatically select values for bgp_cer_cidr and bgp_ibm_cidr.
For explicit IP assignment set a valid bgp_cer_cidr and bgp_ibm_cidr CIDR, the value must reside in one of "10.254.0.0/16", "172.16.0.0/12", "192.168.0.0/16", "169.254.0.0/16" or an owned public CIDR. bgp_cer_cidr and bgp_ibm_cidr must have matching network and subnet mask values.
Examples:169.254.0.9/30Type of services this Gateway is attached to. Mode transit means this Gateway will be attached to Transit Gateway Service and direct means this Gateway will be attached to vpc or classic connection. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Allowable values: [
direct,transit]Default:
directExamples:transit
The default directional route filter action that applies to routes that do not match any directional route filters.
Allowable values: [
permit,deny]Default:
permitExamples:permit
The default directional route filter action that applies to routes that do not match any directional route filters.
Allowable values: [
permit,deny]Default:
permitExamples:permit
Array of directional route filters for a Direct Link gateway. When creating a gateway or replacing existing route filters, the order of the items in the array will set the ordering of the list of route filters.
Possible values: 0 ≤ number of items ≤ 100
- exportRouteFilters
Determines whether routes that match the prefix-set will be allowed (permit) or rejected (deny) through the filter.
Allowable values: [
permit,deny]Examples:permit
The minimum matching length of the prefix-set (mnemonic for greater than or equal to).
Possible values: 1 ≤ value ≤ 32
Examples:25The maximum matching length of the prefix-set (mnemonic for less than or equal to).
Possible values: 1 ≤ value ≤ 32
Examples:30IP prefix representing an address and mask length of the prefix-set.
Possible values: 7 ≤ length ≤ 18, Value must match regular expression
/^([0-9]{1,3}\\.){3}[0-9]{1,3}(\/([0-9]|[1-2][0-9]|3[0-2]))?$/Examples:192.168.100.0/24
Gateways with global routing (
true) can connect to networks outside their associated region.Examples:trueArray of directional route filters for a Direct Link gateway. When creating a gateway or replacing existing route filters, the order of the items in the array will set the ordering of the list of route filters.
Possible values: 0 ≤ number of items ≤ 100
- importRouteFilters
Determines whether routes that match the prefix-set will be allowed (permit) or rejected (deny) through the filter.
Allowable values: [
permit,deny]Examples:permit
The minimum matching length of the prefix-set (mnemonic for greater than or equal to).
Possible values: 1 ≤ value ≤ 32
Examples:25The maximum matching length of the prefix-set (mnemonic for less than or equal to).
Possible values: 1 ≤ value ≤ 32
Examples:30IP prefix representing an address and mask length of the prefix-set.
Possible values: 7 ≤ length ≤ 18, Value must match regular expression
/^([0-9]{1,3}\\.){3}[0-9]{1,3}(\/([0-9]|[1-2][0-9]|3[0-2]))?$/Examples:192.168.100.0/24
Metered billing option. When
truegateway usage is billed per gigabyte. Whenfalsethere is no per gigabyte usage charge, instead a flat rate is charged for the gateway.Examples:falseThe unique user-defined name for this gateway.
Examples:myGateway
Gateway patch panel complete notification from implementation team.
Examples:patch panel configuration details
Resource group for this resource. If unspecified, the account's default resource group is used.
- resourceGroup
Resource group identifier.
Examples:56969d6043e9465c883cb9f7363e78e8
Gateway speed in megabits per second.
Examples:1000Offering type.
Allowable values: [
connect,dedicated]Examples:dedicated
Carrier name.
Possible values: 1 ≤ length ≤ 128, Value must match regular expression
/^[a-zA-Z0-9 _-]+$/Examples:myCarrierName
Cross connect router.
Examples:xcr01.dal03
Customer name.
Possible values: 1 ≤ length ≤ 128, Value must match regular expression
/^[a-zA-Z0-9 _-]+$/Examples:newCustomerName
Gateway location.
Examples:dal03
MACsec configuration information of a Direct Link gateway.
- macsec
Determines if the MACsec feature should initially be active (true) or inactive (false) for a gateway.
Examples:trueList of all connectivity association keys (CAKs) to be associated associated with the MACsec feature on a direct link.
There must be at least one CAK with
session:primary. There can be at most one CAK withsession:fallbackAll CAKs must reference a unique key.
Possible values: 1 ≤ number of items ≤ 4
- caks
- key
The CRN of the key.
Possible values: 9 ≤ length ≤ 512, Value must match regular expression
/^crn:v[0-9](:([A-Za-z0-9-._~!$&'()*+,;=@\/]|%[0-9A-Z]{2})*){2}:hs-crypto(:([A-Za-z0-9-._~!$&'()*+,;=@\/]|%[0-9A-Z]{2})*){5}$/Examples:crn:v1:bluemix:public:hs-crypto:us-south:a/4111d05f36894e3cb9b46a43556d9000:abc111b8-37aa-4034-9def-f2607c87aaaa:key:bbb222bc-430a-4de9-9aad-84e5bb022222
The name identifies the connectivity association key (CAK) within the MACsec key chain.
The CAK's
namemust be a hexadecimal string of even lengths between 2 to 64 inclusive.This value, along with the material of the
key, must match on the MACsec peers.Possible values: 2 ≤ length ≤ 64, Value must match regular expression
/^([0-9a-fA-F]{2}){1,32}$/Examples:1000The intended session the key will be used to secure.
If the
primaryMACsec session fails due to a key/key name mismatch on the peers, thefallbacksession can take over.There must be a
primarysession CAK. AfallbackCAK is optional.Allowable values: [
primary,fallback]
SAK rekey mode based on length of time since last rekey.
- sakRekey
The time, in seconds, to force a Secure Association Key (SAK) rekey.
Possible values: 60 ≤ value ≤ 65535
Examples:3600Determines that the SAK rekey occurs based on a timer.
Allowable values: [
timer]Examples:timer
Determines how packets without MACsec headers are handled.
must_secure- Packets without MACsec headers are dropped. This policy should be used to prefer security over network availability.should_secure- Packets without MACsec headers are allowed. This policy should be used to prefer network availability over security.Allowable values: [
must_secure,should_secure]Examples:must_secure
The window size determines the number of frames in a window for replay protection.
Replay protection is used to counter replay attacks. Frames within a window size can be out of order and are not replay protected.
Possible values: 0 ≤ value ≤ 65535
Default:
512Examples:64
Indicates the direct link's MACsec capability. It must match one of the MACsec related
capabilitiesof thecross_connect_router.- non_macsec: The direct link does not support MACsec.
- macsec: The direct link supports MACsec. The MACsec feature must be enabled.
- macsec_optional: The direct link supports MACsec. The MACsec feature is not required and can be enabled after direct link creation.
If not explicitly provided, the field will be assigned with the following priorities based on
cross_connect_routercapabilities and available ports:macsecwas not provided in the requestnon_macsecmacsec_optional
macsecwas provided in the requestmacsec_optionalmacsec.
Allowable values: [
non_macsec,macsec,macsec_optional]The VLAN to configure for this gateway.
Possible values: 2 ≤ value ≤ 3967
Examples:10
parameters
Gateway fields specific to type=dedicated gateway create.
- gatewayTemplate
array of AS Prepend configuration information.
Possible values: 0 ≤ number of items ≤ 50
- as_prepends
Number of times the ASN to be prepended to the AS Path.
Possible values: 3 ≤ value ≤ 10
Examples:4Route type this AS Prepend applies to.
Allowable values: [
import,export]Examples:import
Comma separated list of prefixes this AS Prepend applies to. Maximum of 10 prefixes. If not specified, this AS Prepend applies to all prefixes.
Examples:172.17.0.0/16Array of prefixes this AS Prepend applies to. If this property is absent, the AS Prepend applies to all prefixes.
Possible values: 1 ≤ number of items ≤ 10, 9 ≤ length ≤ 18, Value must match regular expression
/^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\/(3[0-2]|[1-2][0-9]|[0-9]))$/
- authentication_key
The CRN of the key.
Possible values: 9 ≤ length ≤ 512, Value must match regular expression
/^crn:v[0-9](:([A-Za-z0-9-._~!$&'()*+,;=@\/]|%[0-9A-Z]{2})*){2}:kms(:([A-Za-z0-9-._~!$&'()*+,;=@\/]|%[0-9A-Z]{2})*){5}$/Examples:crn:v1:bluemix:public:kms:us-south:a/4111d05f36894e3cb9b46a43556d9000:abc111b8-37aa-4034-9def-f2607c87aaaa:key:bbb222bc-430a-4de9-9aad-84e5bb022222
BFD configuration information.
- bfd_config
Minimum interval in milliseconds at which the local routing device transmits hello packets and then expects to receive a reply from a neighbor with which it has established a BFD session.
Possible values: 300 ≤ value ≤ 255000
Examples:2000The number of hello packets not received by a neighbor that causes the originating interface to be declared down.
Possible values: 1 ≤ value ≤ 255
Default:
3Examples:10
BGP ASN.
Examples:64999(DEPRECATED) BGP base CIDR.
Field is deprecated. See bgp_ibm_cidr and bgp_cer_cidr for details on how to create a gateway using either automatic or explicit IP assignment. Any bgp_base_cidr value set will be ignored.
Deprecated field bgp_base_cidr will be removed from the API specification after 15-MAR-2021.
BGP customer edge router CIDR.
For auto IP assignment, omit bgp_cer_cidr and bgp_ibm_cidr. IBM will automatically select values for bgp_cer_cidr and bgp_ibm_cidr.
For explicit IP assignment set a valid bgp_cer_cidr and bgp_ibm_cidr CIDR, the value must reside in one of "10.254.0.0/16", "172.16.0.0/12", "192.168.0.0/16", "169.254.0.0/16" or an owned public CIDR. bgp_cer_cidr and bgp_ibm_cidr must have matching network and subnet mask values.
Examples:169.254.0.10/30BGP IBM CIDR.
For auto IP assignment, omit bgp_cer_cidr and bgp_ibm_cidr. IBM will automatically select values for bgp_cer_cidr and bgp_ibm_cidr.
For explicit IP assignment set a valid bgp_cer_cidr and bgp_ibm_cidr CIDR, the value must reside in one of "10.254.0.0/16", "172.16.0.0/12", "192.168.0.0/16", "169.254.0.0/16" or an owned public CIDR. bgp_cer_cidr and bgp_ibm_cidr must have matching network and subnet mask values.
Examples:169.254.0.9/30Type of services this Gateway is attached to. Mode transit means this Gateway will be attached to Transit Gateway Service and direct means this Gateway will be attached to vpc or classic connection. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Allowable values: [
direct,transit]Default:
directExamples:transit
The default directional route filter action that applies to routes that do not match any directional route filters.
Allowable values: [
permit,deny]Default:
permitExamples:permit
The default directional route filter action that applies to routes that do not match any directional route filters.
Allowable values: [
permit,deny]Default:
permitExamples:permit
Array of directional route filters for a Direct Link gateway. When creating a gateway or replacing existing route filters, the order of the items in the array will set the ordering of the list of route filters.
Possible values: 0 ≤ number of items ≤ 100
- export_route_filters
Determines whether routes that match the prefix-set will be allowed (permit) or rejected (deny) through the filter.
Allowable values: [
permit,deny]Examples:permit
The minimum matching length of the prefix-set (mnemonic for greater than or equal to).
Possible values: 1 ≤ value ≤ 32
Examples:25The maximum matching length of the prefix-set (mnemonic for less than or equal to).
Possible values: 1 ≤ value ≤ 32
Examples:30IP prefix representing an address and mask length of the prefix-set.
Possible values: 7 ≤ length ≤ 18, Value must match regular expression
/^([0-9]{1,3}\\.){3}[0-9]{1,3}(\/([0-9]|[1-2][0-9]|3[0-2]))?$/Examples:192.168.100.0/24
Gateways with global routing (
true) can connect to networks outside their associated region.Examples:trueArray of directional route filters for a Direct Link gateway. When creating a gateway or replacing existing route filters, the order of the items in the array will set the ordering of the list of route filters.
Possible values: 0 ≤ number of items ≤ 100
- import_route_filters
Determines whether routes that match the prefix-set will be allowed (permit) or rejected (deny) through the filter.
Allowable values: [
permit,deny]Examples:permit
The minimum matching length of the prefix-set (mnemonic for greater than or equal to).
Possible values: 1 ≤ value ≤ 32
Examples:25The maximum matching length of the prefix-set (mnemonic for less than or equal to).
Possible values: 1 ≤ value ≤ 32
Examples:30IP prefix representing an address and mask length of the prefix-set.
Possible values: 7 ≤ length ≤ 18, Value must match regular expression
/^([0-9]{1,3}\\.){3}[0-9]{1,3}(\/([0-9]|[1-2][0-9]|3[0-2]))?$/Examples:192.168.100.0/24
Metered billing option. When
truegateway usage is billed per gigabyte. Whenfalsethere is no per gigabyte usage charge, instead a flat rate is charged for the gateway.Examples:falseThe unique user-defined name for this gateway.
Examples:myGateway
Gateway patch panel complete notification from implementation team.
Examples:patch panel configuration details
Resource group for this resource. If unspecified, the account's default resource group is used.
- resource_group
Resource group identifier.
Examples:56969d6043e9465c883cb9f7363e78e8
Gateway speed in megabits per second.
Examples:1000Offering type.
Allowable values: [
connect,dedicated]Examples:dedicated
Carrier name.
Possible values: 1 ≤ length ≤ 128, Value must match regular expression
/^[a-zA-Z0-9 _-]+$/Examples:myCarrierName
Cross connect router.
Examples:xcr01.dal03
Customer name.
Possible values: 1 ≤ length ≤ 128, Value must match regular expression
/^[a-zA-Z0-9 _-]+$/Examples:newCustomerName
Gateway location.
Examples:dal03
MACsec configuration information of a Direct Link gateway.
- macsec
Determines if the MACsec feature should initially be active (true) or inactive (false) for a gateway.
Examples:trueList of all connectivity association keys (CAKs) to be associated associated with the MACsec feature on a direct link.
There must be at least one CAK with
session:primary. There can be at most one CAK withsession:fallbackAll CAKs must reference a unique key.
Possible values: 1 ≤ number of items ≤ 4
- caks
- key
The CRN of the key.
Possible values: 9 ≤ length ≤ 512, Value must match regular expression
/^crn:v[0-9](:([A-Za-z0-9-._~!$&'()*+,;=@\/]|%[0-9A-Z]{2})*){2}:hs-crypto(:([A-Za-z0-9-._~!$&'()*+,;=@\/]|%[0-9A-Z]{2})*){5}$/Examples:crn:v1:bluemix:public:hs-crypto:us-south:a/4111d05f36894e3cb9b46a43556d9000:abc111b8-37aa-4034-9def-f2607c87aaaa:key:bbb222bc-430a-4de9-9aad-84e5bb022222
The name identifies the connectivity association key (CAK) within the MACsec key chain.
The CAK's
namemust be a hexadecimal string of even lengths between 2 to 64 inclusive.This value, along with the material of the
key, must match on the MACsec peers.Possible values: 2 ≤ length ≤ 64, Value must match regular expression
/^([0-9a-fA-F]{2}){1,32}$/Examples:1000The intended session the key will be used to secure.
If the
primaryMACsec session fails due to a key/key name mismatch on the peers, thefallbacksession can take over.There must be a
primarysession CAK. AfallbackCAK is optional.Allowable values: [
primary,fallback]
SAK rekey mode based on length of time since last rekey.
- sak_rekey
The time, in seconds, to force a Secure Association Key (SAK) rekey.
Possible values: 60 ≤ value ≤ 65535
Examples:3600Determines that the SAK rekey occurs based on a timer.
Allowable values: [
timer]Examples:timer
Determines how packets without MACsec headers are handled.
must_secure- Packets without MACsec headers are dropped. This policy should be used to prefer security over network availability.should_secure- Packets without MACsec headers are allowed. This policy should be used to prefer network availability over security.Allowable values: [
must_secure,should_secure]Examples:must_secure
The window size determines the number of frames in a window for replay protection.
Replay protection is used to counter replay attacks. Frames within a window size can be out of order and are not replay protected.
Possible values: 0 ≤ value ≤ 65535
Default:
512Examples:64
Indicates the direct link's MACsec capability. It must match one of the MACsec related
capabilitiesof thecross_connect_router.- non_macsec: The direct link does not support MACsec.
- macsec: The direct link supports MACsec. The MACsec feature must be enabled.
- macsec_optional: The direct link supports MACsec. The MACsec feature is not required and can be enabled after direct link creation.
If not explicitly provided, the field will be assigned with the following priorities based on
cross_connect_routercapabilities and available ports:macsecwas not provided in the requestnon_macsecmacsec_optional
macsecwas provided in the requestmacsec_optionalmacsec.
Allowable values: [
non_macsec,macsec,macsec_optional]The VLAN to configure for this gateway.
Possible values: 2 ≤ value ≤ 3967
Examples:10
parameters
Gateway fields specific to type=dedicated gateway create.
- gateway_template
array of AS Prepend configuration information.
Possible values: 0 ≤ number of items ≤ 50
- as_prepends
Number of times the ASN to be prepended to the AS Path.
Possible values: 3 ≤ value ≤ 10
Examples:4Route type this AS Prepend applies to.
Allowable values: [
import,export]Examples:import
Comma separated list of prefixes this AS Prepend applies to. Maximum of 10 prefixes. If not specified, this AS Prepend applies to all prefixes.
Examples:172.17.0.0/16Array of prefixes this AS Prepend applies to. If this property is absent, the AS Prepend applies to all prefixes.
Possible values: 1 ≤ number of items ≤ 10, 9 ≤ length ≤ 18, Value must match regular expression
/^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\/(3[0-2]|[1-2][0-9]|[0-9]))$/
- authentication_key
The CRN of the key.
Possible values: 9 ≤ length ≤ 512, Value must match regular expression
/^crn:v[0-9](:([A-Za-z0-9-._~!$&'()*+,;=@\/]|%[0-9A-Z]{2})*){2}:kms(:([A-Za-z0-9-._~!$&'()*+,;=@\/]|%[0-9A-Z]{2})*){5}$/Examples:crn:v1:bluemix:public:kms:us-south:a/4111d05f36894e3cb9b46a43556d9000:abc111b8-37aa-4034-9def-f2607c87aaaa:key:bbb222bc-430a-4de9-9aad-84e5bb022222
BFD configuration information.
- bfd_config
Minimum interval in milliseconds at which the local routing device transmits hello packets and then expects to receive a reply from a neighbor with which it has established a BFD session.
Possible values: 300 ≤ value ≤ 255000
Examples:2000The number of hello packets not received by a neighbor that causes the originating interface to be declared down.
Possible values: 1 ≤ value ≤ 255
Default:
3Examples:10
BGP ASN.
Examples:64999(DEPRECATED) BGP base CIDR.
Field is deprecated. See bgp_ibm_cidr and bgp_cer_cidr for details on how to create a gateway using either automatic or explicit IP assignment. Any bgp_base_cidr value set will be ignored.
Deprecated field bgp_base_cidr will be removed from the API specification after 15-MAR-2021.
BGP customer edge router CIDR.
For auto IP assignment, omit bgp_cer_cidr and bgp_ibm_cidr. IBM will automatically select values for bgp_cer_cidr and bgp_ibm_cidr.
For explicit IP assignment set a valid bgp_cer_cidr and bgp_ibm_cidr CIDR, the value must reside in one of "10.254.0.0/16", "172.16.0.0/12", "192.168.0.0/16", "169.254.0.0/16" or an owned public CIDR. bgp_cer_cidr and bgp_ibm_cidr must have matching network and subnet mask values.
Examples:169.254.0.10/30BGP IBM CIDR.
For auto IP assignment, omit bgp_cer_cidr and bgp_ibm_cidr. IBM will automatically select values for bgp_cer_cidr and bgp_ibm_cidr.
For explicit IP assignment set a valid bgp_cer_cidr and bgp_ibm_cidr CIDR, the value must reside in one of "10.254.0.0/16", "172.16.0.0/12", "192.168.0.0/16", "169.254.0.0/16" or an owned public CIDR. bgp_cer_cidr and bgp_ibm_cidr must have matching network and subnet mask values.
Examples:169.254.0.9/30Type of services this Gateway is attached to. Mode transit means this Gateway will be attached to Transit Gateway Service and direct means this Gateway will be attached to vpc or classic connection. The list of enumerated values for this property may expand in the future. Code and processes using this field must tolerate unexpected values.
Allowable values: [
direct,transit]Default:
directExamples:transit
The default directional route filter action that applies to routes that do not match any directional route filters.
Allowable values: [
permit,deny]Default:
permitExamples:permit
The default directional route filter action that applies to routes that do not match any directional route filters.
Allowable values: [
permit,deny]Default:
permitExamples:permit
Array of directional route filters for a Direct Link gateway. When creating a gateway or replacing existing route filters, the order of the items in the array will set the ordering of the list of route filters.
Possible values: 0 ≤ number of items ≤ 100
- export_route_filters
Determines whether routes that match the prefix-set will be allowed (permit) or rejected (deny) through the filter.
Allowable values: [
permit,deny]Examples:permit
The minimum matching length of the prefix-set (mnemonic for greater than or equal to).
Possible values: 1 ≤ value ≤ 32
Examples:25The maximum matching length of the prefix-set (mnemonic for less than or equal to).
Possible values: 1 ≤ value ≤ 32
Examples:30IP prefix representing an address and mask length of the prefix-set.
Possible values: 7 ≤ length ≤ 18, Value must match regular expression
/^([0-9]{1,3}\\.){3}[0-9]{1,3}(\/([0-9]|[1-2][0-9]|3[0-2]))?$/Examples:192.168.100.0/24
Gateways with global routing (
true) can connect to networks outside their associated region.Examples:trueArray of directional route filters for a Direct Link gateway. When creating a gateway or replacing existing route filters, the order of the items in the array will set the ordering of the list of route filters.
Possible values: 0 ≤ number of items ≤ 100
- import_route_filters
Determines whether routes that match the prefix-set will be allowed (permit) or rejected (deny) through the filter.
Allowable values: [
permit,deny]Examples:permit
The minimum matching length of the prefix-set (mnemonic for greater than or equal to).
Possible values: 1 ≤ value ≤ 32
Examples:25The maximum matching length of the prefix-set (mnemonic for less than or equal to).
Possible values: 1 ≤ value ≤ 32
Examples:30IP prefix representing an address and mask length of the prefix-set.
Possible values: 7 ≤ length ≤ 18, Value must match regular expression
/^([0-9]{1,3}\\.){3}[0-9]{1,3}(\/([0-9]|[1-2][0-9]|3[0-2]))?$/Examples:192.168.100.0/24
Metered billing option. When
truegateway usage is billed per gigabyte. Whenfalsethere is no per gigabyte usage charge, instead a flat rate is charged for the gateway.Examples:falseThe unique user-defined name for this gateway.
Examples:myGateway
Gateway patch panel complete notification from implementation team.
Examples:patch panel configuration details
Resource group for this resource. If unspecified, the account's default resource group is used.
- resource_group
Resource group identifier.
Examples:56969d6043e9465c883cb9f7363e78e8
Gateway speed in megabits per second.
Examples:1000Offering type.
Allowable values: [
connect,dedicated]Examples:dedicated
Carrier name.
Possible values: 1 ≤ length ≤ 128, Value must match regular expression
/^[a-zA-Z0-9 _-]+$/Examples:myCarrierName
Cross connect router.
Examples:xcr01.dal03
Customer name.
Possible values: 1 ≤ length ≤ 128, Value must match regular expression
/^[a-zA-Z0-9 _-]+$/Examples:newCustomerName
Gateway location.
Examples:dal03
MACsec configuration information of a Direct Link gateway.
- macsec
Determines if the MACsec feature should initially be active (true) or inactive (false) for a gateway.
Examples:trueList of all connectivity association keys (CAKs) to be associated associated with the MACsec feature on a direct link.
There must be at least one CAK with
session:primary. There can be at most one CAK withsession:fallbackAll CAKs must reference a unique key.
Possible values: 1 ≤ number of items ≤ 4
- caks
- key
The CRN of the key.
Possible values: 9 ≤ length ≤ 512, Value must match regular expression
/^crn:v[0-9](:([A-Za-z0-9-._~!$&'()*+,;=@\/]|%[0-9A-Z]{2})*){2}:hs-crypto(:([A-Za-z0-9-._~!$&'()*+,;=@\/]|%[0-9A-Z]{2})*){5}$/Examples:crn:v1:bluemix:public:hs-crypto:us-south:a/4111d05f36894e3cb9b46a43556d9000:abc111b8-37aa-4034-9def-f2607c87aaaa:key:bbb222bc-430a-4de9-9aad-84e5bb022222
The name identifies the connectivity association key (CAK) within the MACsec key chain.
The CAK's
namemust be a hexadecimal string of even lengths between 2 to 64 inclusive.This value, along with the material of the
key, must match on the MACsec peers.Possible values: 2 ≤ length ≤ 64, Value must match regular expression
/^([0-9a-fA-F]{2}){1,32}$/Examples:1000The intended session the key will be used to secure.
If the
primaryMACsec session fails due to a key/key name mismatch on the peers, thefallbacksession can take over.There must be a
primarysession CAK. AfallbackCAK is optional.Allowable values: [
primary,fallback]
SAK rekey mode based on length of time since last rekey.
- sak_rekey
The time, in seconds, to force a Secure Association Key (SAK) rekey.
Possible values: 60 ≤ value ≤ 65535
Examples:3600Determines that the SAK rekey occurs based on a timer.
Allowable values: [
timer]Examples:timer
Determines how packets without MACsec headers are handled.
must_secure- Packets without MACsec headers are dropped. This policy should be used to prefer security over network availability.should_secure- Packets without MACsec headers are allowed. This policy should be used to prefer network availability over security.Allowable values: [
must_secure,should_secure]Examples:must_secure
The window size determines the number of frames in a window for replay protection.
Replay protection is used to counter replay attacks. Frames within a window size can be out of order and are not replay protected.
Possible values: 0 ≤ value ≤ 65535
Default:
512Examples:64
Indicates the direct link's MACsec capability. It must match one of the MACsec related
capabilitiesof thecross_connect_router.- non_macsec: The direct link does not support MACsec.
- macsec: The direct link supports MACsec. The MACsec feature must be enabled.
- macsec_optional: The direct link supports MACsec. The MACsec feature is not required and can be enabled after direct link creation.
If not explicitly provided, the field will be assigned with the following priorities based on
cross_connect_routercapabilities and available ports:macsecwas not provided in the requestnon_macsecmacsec_optional
macsecwas provided in the requestmacsec_optionalmacsec.
Allowable values: [
non_macsec,macsec,macsec_optional]The VLAN to configure for this gateway.
Possible values: 2 ≤ value ≤ 3967
Examples:10
WithContext method only
A context.Context instance that you can use to specify a timeout for the operation or to cancel an in-flight request.
The CreateGateway options.
Gateway fields specific to type=dedicated gateway create.
- GatewayTemplate
array of AS Prepend configuration information.
Possible values: 0 ≤ number of items ≤ 50
- AsPrepends
Number of times the ASN to be prepended to the AS Path.
Possible values: 3 ≤ value ≤ 10
Examples:4Route type this AS Prepend applies to.
Allowable values: [
import,export]Examples:import
Comma separated list of prefixes this AS Prepend applies to. Maximum of 10 prefixes. If not specified, this AS Prepend applies to all prefixes.
Examples:172.17.0.0/16Array of prefixes this AS Prepend applies to. If this property is absent, the AS Prepend applies to all prefixes.
Possible values: 1 ≤ number of items ≤ 10, 9 ≤ length ≤ 18, Value must match regular expression
/^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])(\/(3[0-2]|[1-2][0-9]|[0-9]))$/
- AuthenticationKey
The CRN of the key.
Possible values: 9 ≤ length ≤ 512, Value must match regular expression
/^crn:v[0-9](:([A-Za-z0-9-._~!$&'()*+,;=@\/]|%[0-9A-Z]{2})*){2}:kms(:([A-Za-z0-9-._~!$&'()*+,;=@\/]|%[0-9A-Z]{2})*){5}$/Examples:crn:v1:bluemix:public:kms:us-south:a/4111d05f36894e3cb9b46a43556d9000:abc111b8-37aa-4034-9def-f2607c87aaaa:key:bbb222bc-430a-4de9-9aad-84e5bb022222
BFD configuration information.
- BfdConfig
Minimum interval in milliseconds at which the local routing device transmits hello packets and then expects to receive a reply from a neighbor with which it has established a BFD session.
Possible values: 300 ≤ value ≤ 255000
Examples:2000The number of hello packets not received by a neighbor that causes the originating interface to be declared down.
Possible values: 1 ≤ value ≤ 255
Default:
3Examples:10
BGP ASN.
Examples:64999(DEPRECATED) BGP base CIDR.
Field is deprecated. See bgp_ibm_cidr and bgp_cer_cidr for details on how to create a gateway using either automatic or explicit IP assignment. Any bgp_base_cidr value set will be ignored.
Deprecated field bgp_base_cidr will be removed from the API specification after 15-MAR-2021.
BGP customer edge router CIDR.
For auto IP assignment, omit bgp_cer_cidr and bgp_ibm_cidr. IBM will automatically select values for bgp_cer_cidr and bgp_ibm_cidr.
For explicit IP assignment set a valid bgp_cer_cidr and bgp_ibm_cidr CIDR, the value must reside in one of "10.254.0.0/16", "172.16.0.0/12", "192.168.0.0/16", "169.254.0.0/16" or an owned public CIDR. bgp_cer_cidr and bgp_ibm_cidr must have matching network and subnet mask values.
Examples:169.254.0.10/30BGP IBM CIDR.
[...]
